;Equates for DOS-like interface
current_dir EQU statvars		;128 bytes - ASCIIZ string, "\",0 is the default
file_count EQU statvars+128	;16-bit count of files in the current folder
dir_cluster EQU statvars+130	;16-bit starting cluster of current folder
file_start EQU statvars+132	;16-bit starting file count of present screen (default is 0)
file_cur EQU statvars+134		;16-bit currently selected file
cur_entry EQU statvars+136		;32 bytes for currently selected file's directory entry

Explore:
	ld a,1
	out (20h),a		;set fast speed
	B_CALL DelRes
   ;First initialize and set up USB drive
	call initializeMSD
	call sendReset
	ld a,errResetErr
	jp c,displayErr
	call UFI_getName
	call UFI_getCapacity
	ld de,savesscreen
	call UFI_Initialize
	call FAT_Initialize
	ld hl,Root_Directory
	ld de,current_dir
	ldi
	ldi
Explore_ListDirectory:
	ld hl,current_dir
	call DOS_countFilesInDir
	ld (file_count),bc
	ld hl,1170
	or a
	sbc hl,bc
	jp c,AppExit
	ld hl,current_dir+1
	ld a,(hl)
	or a
	jr nz,$F
	ld hl,0
	jr Explore_LD_1
$$:
	dec hl
	call FAT_lookupPath
	ld de,26
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
Explore_LD_1:
	ld (dir_cluster),hl
	ld hl,3
	ld (pencol),hl
	ld hl,0
	ld (file_start),hl
	ld (file_cur),hl
	B_CALL ClrScrnFull
	ld de,3*256+3
	ld (currow),de
	ld hl,Explore_IndexingMessage
	call putstring
	;Populate RAM page 87h with the names, 86h with pointers
	ld ix,8000h
	ld bc,-1
	ld de,8000h
Explore_PopulateL:
	push de
	push ix
	ld hl,(dir_cluster)
	call DOS_getNextFile
	pop ix
	pop de
	jr c,$F
	ld a,(hl)
	cp '.'
	jr nz,Explore_PopulateL3
	inc hl
	ld a,(hl)
	dec hl
	cp '.'
	jr z,Explore_PopulateL3
	ld hl,(file_count)
	dec hl
	ld (file_count),hl
	jr Explore_PopulateL
Explore_PopulateL3:
	push bc
	push hl
	push de
	ld bc,12
	ld de,symtable+1
	ldir
	pop de
	pop hl
	di
	ld a,86h
	out (7),a
	ld (ix),e
	ld (ix+1),d
	inc ix
	inc ix
	ld a,87h
	out (7),a
	ld hl,symtable+1
	ld bc,12
	ldir
	pop bc
	ld a,c
	ld (de),a
	inc de
	ld a,b
	ld (de),a
	inc de
	ld a,81h
	out (7),a
	ei
	jr Explore_PopulateL
$$:
	;Ready to sort!?
	ld de,3*256+3
	ld (currow),de
	ld hl,Explore_SortMessage
	call putstring
	;Begin quicksort
	di
	ld hl,(file_count)
	ld a,86h
	out (7),a
	;Quicksort algorithm starts here
	dec hl
	add hl,hl
	ld bc,8000h
	add hl,bc
	ex de,hl
	ld hl,8000h
	call Explore_QuickSort
	ld a,81h
	out (7),a
	ei
	B_CALL ClrLCDFull
	B_CALL GrBufClr
	ld hl,0
	ld de,6*256+95
	B_CALL FillRect
	ld hl,current_dir
	set textInverse,(iy+textFlags)
	call vputstring
	res textInverse,(iy+textFlags)
	ld bc,51*256+7
	ld de,51*256+57
	B_CALL DarkLine
	ld bc,7
	ld de,95*256+7
	B_CALL DarkLine
	ld bc,19*256+7
	ld de,19*256
	B_CALL DarkLine
	ld bc,38*256+7
	ld de,38*256
	B_CALL DarkLine
	ld bc,57*256+7
	ld de,57*256
	B_CALL DarkLine
	ld bc,76*256+7
	ld de,76*256
	B_CALL DarkLine
Explore_LoopBack:
	call Explore_ListFiles
Explore_LoopBack_NoList:
	;Display information for the current file
	ld hl,Explore_Size
	ld de,8*256+53
	ld (pencol),de
	call vputstring
	ld a,70
	ld (pencol),a
	di
	ld hl,(file_cur)
	ld a,86h
	out (7),a
	add hl,hl
	set 7,h
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld a,87h
	out (7),a
	ld de,12
	add hl,de
	ld c,(hl)
	inc hl
	ld b,(hl)
	ld a,81h
	out (7),a
	ei
	;BC is the entry number
	ld hl,(dir_cluster)
	call DOS_getDirEntry
	ld de,cur_entry
	ld bc,32
	ldir
	ld hl,cur_entry
	call DOS_getFileSize_DirEntry
	call Explore_DisplayFileSize
	ld hl,15*256+53
	ld (pencol),hl
	ld hl,Explore_Attr
	call vputstring
	ld a,70
	ld (pencol),a
	ld b,6
	ld a,(cur_entry+11)
	ld hl,Explore_Attrs-1
Explore_Attr_L:
	inc hl
	rra
	jr nc,$F
	push af
	ld a,(hl)
	or a
	jr z,Explore_Attr_L2
	B_CALL VPutMap
	ld a,' '
	B_CALL VPutMap
Explore_Attr_L2:
	pop af
$$:
	djnz Explore_Attr_L
	;Display byte size
	ld hl,29*256+53
	ld (pencol),hl
	ld hl,cur_entry
	call DOS_getFileSize_DirEntry
	call Explore_DisplayByteSize
	ld b,8
$$:
	ld a,6
	B_CALL VPutMap
	djnz $B
	ld hl,36*256+53
	ld (pencol),hl
	ld hl,(cur_entry+24)
	srl h
	rr l
	ld a,l
	and 11110000b
	rrca
	rrca
	rrca
	rrca
	call DispA
	ld a,'-'
	B_CALL VPutMap
	ld hl,(cur_entry+24)
	ld a,l
	and 00011111b
	call DispA
	ld a,'-'
	B_CALL VPutMap
	ld a,h
	and 11111110b
	rrca
	cp 20
	jr c,$F
	sub 100
$$:
	add a,80
	call DispA
	;
	ld hl,43*256+53
	ld (pencol),hl
	ld hl,(cur_entry+22)
	ld a,h
	and 11111000b
	rrca
	rrca
	rrca
	call DispA
	ld a,':'
	B_CALL VPutMap
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,h
	and 00111111b
	call DispA
	ld a,':'
	B_CALL VPutMap
	ld a,l
	and 11111000b
	rrca
	rrca
	rrca
	add a,a
	call DispA
Explore_KeyLoop:
	ei
	halt
	halt
	B_CALL GetKey
	cp kDown
	jr z,Explore_KeyDown
	cp kUp
	jr z,Explore_KeyUp
	cp kEnter
	jr z,Explore_KeyEnter
	cp kClear
	jp z,AppExit
	jr Explore_KeyLoop
;Explore_CopyPrgm_8xp:
;	DB "8XP"
;Explore_CopyPrgm:
;	ld hl,cur_entry+8
;	ld de,Explore_CopyPrgm_8xp
;	ld b,3
;Explore_CopyPrgm_Check:
;	ld a,(de)
;	cp (hl)
;	jr nz,Explore_KeyLoop
;	inc hl
;	inc de
;	djnz Explore_CopyPrgm_Check
;	;It is a .8xp file! YAHOO!
;	;Let's open it up and take a look at the innards
;	;
;	ld hl,current_dir
;	ld bc,128
;	ld de,ramcode
;	ldir
;	ld hl,ramcode
;	xor a
;	ld bc,128
;	cpir
;	dec hl
;	dec hl
;	ld a,(hl)
;	inc hl
;	cp '/'
;	jr z,Explore_KeyEnter_OOOHLALA
;	ld (hl),'/'
;	inc hl
;Explore_KeyEnter_OOOHLALA:
;	push hl
;	ld de,OP1
;	ld hl,cur_entry
;	call FAT_nameConvertFrom11
;	pop de
;Explore_KeyEnter_1234timetoshutthedoor:
;	ld a,(hl)
;	or a
;	jr z,$F
;	ld (de),a
;	inc hl
;	inc de
;	jr Explore_KeyEnter_1234timetoshutthedoor
;$$:
;	xor a
;	ld (de),a
;	ld de,OP3
;	ld hl,ramcode
;	call DOS_openFile
;	jp c,Explore_KeyLoop
;	ld hl,OP3
;	ld de,8000h
;	ld bc,8
;	call DOS_fileRead
;	ld hl,8000h
;	ld de,Explore_discomusicisbackbaby
;	ld b,8
;Explore_hmm:
;	ld a,(de)
;	cp (hl)
;	jr nz,Explore_KeyLoop
;	inc hl
;	inc de
;	djnz Explore_hmm
;	;Match
;Explore_discomusicisbackbaby:
;	DB "**TI83F*"
Explore_KeyEnter:
	;Enter was pressed.
	ld a,(cur_entry+11)
	and 10h
	jr z,Explore_KeyLoop
	;It's a directory.
	;Check if it's ..
	ld a,(cur_entry)
	cp '.'
	jr nz,$F
	ld a,(cur_entry+1)
	cp '.'
	jr nz,$F
	;Move up a directory
	ld hl,current_dir
	xor a
	ld bc,128
	cpir
	ld a,'/'
	ld bc,128
	cpdr
	ld de,current_dir
	or a
	sbc hl,de
	jr c,Explore_KeyEnter_MoveUp
	add hl,de
	inc hl
	ld (hl),0
	jp Explore_ListDirectory
Explore_KeyEnter_MoveUp:
	xor a
	ld (current_dir+1),a
	jp Explore_ListDirectory
$$:
	ld hl,current_dir
	xor a
	ld bc,128
	cpir
	dec hl
	dec hl
	ld a,(hl)
	inc hl
	cp '/'
	jr z,Explore_KeyEnter_LALALA
	ld (hl),'/'
	inc hl
Explore_KeyEnter_LALALA:
	push hl
	ld de,OP1
	ld hl,cur_entry
	call FAT_nameConvertFrom11
	pop de
Explore_KeyEnter_1:
	ld a,(hl)
	or a
	jr z,$F
	ld (de),a
	inc hl
	inc de
	jr Explore_KeyEnter_1
$$:
	xor a
	ld (de),a
	jp Explore_ListDirectory
Explore_KeyUp:
	ld hl,(file_cur)
	ld (OP4),hl
	ld a,h
	or l
	jr z,Explore_LoopBack
	dec hl
	ld (file_cur),hl
	ld de,(file_start)
	or a
	sbc hl,de
	jr nc,Explore_KeyDown_Rects
	dec de
	ld (file_start),de
	jr Explore_LoopBack
Explore_KeyDown:
	ld de,(file_cur)
	ld (OP4),de
	inc de
	ld hl,(file_count)
	or a
	sbc hl,de
	jr z,Explore_KeyLoop
	ld (file_cur),de
	ld hl,(file_start)
	ld bc,7
	add hl,bc
	ex de,hl
	or a
	sbc hl,de
	jr c,Explore_KeyDown_Rects
	ld de,(file_start)
	inc de
	ld (file_start),de
	jr Explore_LoopBack
Explore_KeyDown_Rects:
	;Turn off original black rectangle
	ld hl,(OP4)
	ld de,(file_start)
	or a
	sbc hl,de
	call Explore_Rects_R
	ld hl,(file_cur)
	ld de,(file_start)
	or a
	sbc hl,de
	call Explore_Rects_R
	jr Explore_LoopBack_NoList
Explore_Rects_R:
	ld a,l
	add a,a
	ld b,a
	add a,a
	add a,b
	add a,8
	ld h,a
	add a,5
	ld d,a
	ld l,0
	ld e,50
	B_CALL InvertRect
	ret
Explore_ListFiles:
	ld de,8*256
	ld (pencol),de
	ld hl,(file_start)
	ld b,7
Explore_ListFiles_Loop:
	push bc
	ld de,(file_count)
	or a
	sbc hl,de
	jr z,Explore_LF_D
	add hl,de
	di
	push hl
	add hl,hl
	ld de,8000h
	add hl,de
	ld a,86h
	out (7),a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld a,87h
	out (7),a
	ld de,symtable+1
	ld bc,12
	ldir
	ld a,81h
	out (7),a
	ei
	ld hl,symtable+1
	ld de,OP1
	call FAT_nameConvertFrom11
	ld a,(symtable+1+11)
	and 10h
	ld a,6
	jr z,$F
	ld a,'+'
$$:
	B_CALL VPutMap
	call vputstring
Explore_LFL3:
	ld a,(pencol)
	cp 51
	jr nc,Explore_LFL4
	ld a,' '
	B_CALL VPutMap
	jr Explore_LFL3
Explore_LFL4:
	xor a
	ld (pencol),a
	ld a,(penrow)
	add a,6
	ld (penrow),a
	pop hl
	push hl
	ld de,(file_cur)
	or a
	sbc hl,de
	jr nz,$F
	add hl,de
	ld de,(file_start)
	or a
	sbc hl,de
	call Explore_Rects_R
$$:
	pop hl
	inc hl
	pop bc
	djnz Explore_ListFiles_Loop
	ret
Explore_LF_D:
	pop bc
	ret
Root_Directory:
    DB "/",0
Explore_IndexingMessage:
	DB "INDEXING...",0
Explore_SortMessage:
	DB "SORTING...",0
Explore_Attrs:
	DB "RHS",0,0,"A"
vputstring:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL VPutMap
	jr vputstring
putstring:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL PutC
	jr putstring
OP7 EQU symtable+1
Explore_QuickSort:
	;QuickSort
	;Input - HL is low, DE is high
	;if (high <= low), then terminate
	or a
	sbc hl,de
	ret nc
	add hl,de
	;pivot = partition(a, low, high)
	push de
	push hl
	call Explore_Partition
	pop hl
	;quicksort (a,low,pivot-1)
	push de
	dec de
	dec de
	call Explore_QuickSort
	pop hl
	inc hl
	inc hl
	pop de
	jr Explore_QuickSort
Explore_Partition:
	;Partition routine for quicksort.
	;Assume that interrupts are disabled and page 86h is active on port 7.
	;Parameters passed in are int low and int high (pointers)
	;Input - HL is low, DE is high
	;Output - Returns in DE (right)
	;pivot_item = a[low];
	ld (OP7),hl		;pivot_item
	;pivot = left = low
	ld (OP7+2),hl
	;right = high
	ld (OP7+4),de
	;left is HL, right is DE
	;while (left<right) {
Explore_P_1:
	or a
	sbc hl,de
Explore_P_1_LB:
	jr nc,Explore_P_2
	add hl,de
	;while (a[left] <= pivot_item) left++;
Explore_P_3:
	;HL is left.
	push de
	ld de,(OP7)
	call Explore_Sort_Compare
	pop de
	jr c,Explore_P_4
	;left++ now
	inc hl
	inc hl
	push hl
	ld bc,(OP7+4)
	inc bc
	inc bc
	sbc hl,bc
	pop hl
	jr nz,Explore_P_3
	;left went past the bounds of the array
	;this means the left pivot is greater than all.
	ld hl,(OP7)
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc de
	ld a,(de)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	dec hl
	ld a,(de)
	ld (hl),a
	ld a,c
	ld (de),a
	ret
	;while (a[right] < pivot_item) right--;
Explore_P_4:
	;DE is right.
	push hl
	ld hl,(OP7)
	call Explore_Sort_Compare
	pop hl
	jr c,Explore_P_5
	dec de
	dec de
	push hl
	ld hl,(OP7+2)
	or a
	sbc hl,de
	pop hl
	jr c,Explore_P_4
	jr z,Explore_P_4
	ld de,(OP7+2)
	ret
Explore_P_5:
	;if (left<right) SWAP(a,left,right)
	or a
	sbc hl,de
	jr nc,Explore_P_1_LB
	;}
	add hl,de
	ld bc,(OP7)
	or a
	sbc hl,bc
	jr nz,$F
	ld (OP7),de
$$:
	add hl,bc
	;SWAP them!
	ld c,(hl)
	inc hl
	ld b,(hl)
	dec hl
	ld a,(de)
	ld (hl),a
	inc de
	inc hl
	ld a,(de)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	ld a,c
	ld (de),a
	dec hl
	jr Explore_P_1
Explore_P_2:
	;a[low] = a[right];
	ld hl,(OP7+2)
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc de
	ld a,(de)
	ld (hl),a
	ld a,b
	ld (de),a
	dec de
	dec hl
	ld a,(de)
	ld (hl),a
	ld a,c
	ld (de),a
	ret
	;}
Explore_Sort_Compare:
	;Input - HL,DE are pointers to page 86h entries to compare
	;Destroys AF only. Uses shadow registers.
	;Output - Z if DE = HL. C if HL > DE. NC if HL <= DE.
	push hl
	push de
	exx
	pop hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	pop hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;DE, HL are pointers
	ld a,87h
	out (7),a
	push hl
	push de
	ld bc,11
	add hl,bc
	ex de,hl
	add hl,bc
	ld a,(hl)
	and 10h
	ld b,a
	ld a,(de)
	and 10h
	cp b
	pop de
	pop hl
	jr nz,Explore_Sort_Compare_D
	ld b,11
Explore_Sort_Compare_L:
	ld a,(de)
	cp (hl)
	jr nz,Explore_Sort_Compare_D
	inc hl
	inc de
	djnz Explore_Sort_Compare_L
	xor a
Explore_Sort_Compare_D:
	ld a,86h
	out (7),a
	exx
	ret
Divide32:
	;DEHL is quotient when done. A is the remainder.
	ld c,a
	xor a
	ld b,32
Divide32_Loop:
	add hl,hl
	rl e
	rl d
	rla
	jr c,Divide32_Fit
	cp c
	jr c,Divide32_NoFit
Divide32_Fit:
	sub c
	inc l
Divide32_NoFit:
	djnz Divide32_Loop
	ret
Explore_Size:
	DB "Size:",6,6,6,6,6,6,0
Explore_Attr:
	DB "Attr:",6,6,6,6,6,6,0
Explore_DisplayFileSize:
	;Input - DEHL is a 32-bit number.
	;Output - Displays the file size.
	;Bytes for <= 64 KB
	;Kilobytes for <=16MB
	;Megabytes otherwise
	ld a,d
	or a
	jr z,$F
	;We have at least 16 MB. Divide by 2^20
	ld h,d
	ld l,e
	ld de,0
	srl h
	rr l
	srl h
	rr l
	srl h
	rr l
	srl h
	rr l
	ld a,'M'
	ld (OP6),a
	jr Explore_DFS_1
$$:
	;Check for over 64 KB?
	ld a,e
	or e
	jr z,$F
	;Divide by 2^10.
	ld l,h
	ld h,e
	ld e,0
	srl h
	rr l
	srl h
	rr l
	ld a,'K'
	ld (OP6),a
	jr Explore_DFS_1
$$:
Explore_DisplayByteSize:
	xor a
	ld (OP6),a
Explore_DFS_1:
	ld ix,OP5+10
	ld (ix+2),0
Explore_DFS_2:
	ld a,10
	call Divide32
	;A is remainder
	add a,'0'
	ld (ix),a
	dec ix
	ld a,d
	or e
	or h
	or l
	jr nz,Explore_DFS_2
	push ix
	pop hl
	inc hl
	jp vputstring
DispA:
	push hl
	ld c,-1
DispA_loop:
	inc c
	sub 10
	jr nc,DispA_loop
	add a,10
	push af
	ld a,c
	add a,'0'
	B_CALL VPutMap
	pop af
	add a,'0'
	B_CALL VPutMap
	pop hl
	ret
